/* SPDX-License-Identifier: (GPL-2.0+ OR MIT) */
/*
 * Copyright (C) 2018, 2019 Telechips Inc.
 */

#ifndef __DT_TELECHIPS_TCC803X_CLKS_H__
#define __DT_TELECHIPS_TCC803X_CLKS_H__

#include "telechips,clk-common.h"

/* CLKCTRL channel index */
#define FBUS_CPU0		0UL	//   Cortex-A7 MP
#define FBUS_CPU1		1UL	//   Cortex-A7 SP
#define FBUS_CBUS		2UL	// CLKCTRL2
#define FBUS_CMBUS		3UL	// CLKCTRL3 (Cortex-M4)
#define FBUS_MEM		4UL	// CLKCTRL4
#define FBUS_VBUS		5UL	// CLKCTRL5
#define FBUS_HSIO		6UL	// CLKCTRL6
#define FBUS_SMU		7UL	// CLKCTRL7
#define FBUS_GPU		8UL	//   GRAPHIC 3D
#define FBUS_DDI		9UL	// CLKCTRL9
#define FBUS_G2D		10UL	//   GRAPHIC 2D
#define FBUS_IO			11UL	// CLKCTRL11
#define FBUS_CODA		12UL	// Video Coda clock
#define FBUS_CHEVC		13UL	// Video CHEVC clock
#define FBUS_BHEVC		15UL	// Video BHEVC clock
#define FBUS_MEM_PHY		16UL	//   Memory PHY.
#define FBUS_MAX		17UL

/* Peripheral Clocks */
#define	PERI_TCX		0UL
#define	PERI_TCT		1UL
#define	PERI_TCZ		2UL
#define	PERI_RESERVED0		3UL
#define	PERI_RESERVED1		4UL
#define IOBUS_ASRC_DMA		5UL
#define IOBUS_ASRC		6UL
#define	PERI_RESERVED2		7UL
#define	PERI_LCDTIMER		8UL
#define	PERI_LCD0		9UL
#define	PERI_LCD1		10UL
#define	PERI_LCD2		11UL
#define	PERI_CPUINTERFACE0	12UL
#define	PERI_CPUINTERFACE1	13UL
#define	PERI_HDMI_CORE		14UL
#define	PERI_HDMI_AUDIO		15UL
#define	PERI_HDMI_PCLK		16UL
#define	PERI_HDMI_CEC		17UL
#define	PERI_HDMI_HDCP14	18UL
#define	PERI_HDMI_HDCP22	19UL
#define	PERI_RESERVED5		20UL
#define	PERI_RESERVED6		21UL
#define	PERI_RESERVED7		22UL
#define	PERI_RESERVED8		23UL
#define	PERI_GMAC		24UL
#define	PERI_PCIE_PCS		25UL
#define	PERI_GMAC_PTP		26UL
#define	PERI_PCIE_AUX		27UL
#define	PERI_PCIE_REF_EXT	28UL
#define	PERI_PCIE_APB		29UL
#define	PERI_RESERVED9		30UL
#define	PERI_RESERVED10		31UL
#define	PERI_MIPI_CSI		32UL
#define	PERI_RESERVED11		33UL
#define	PERI_RESERVED12		34UL
#define	PERI_RESERVED13		35UL
#define	PERI_RESERVED14		36UL
#define	PERI_RESERVED15		37UL
#define	PERI_RESERVED16		38UL
#define	PERI_RESERVED17		39UL
#define	PERI_RMT		40UL
#define	PERI_SDMMC0		41UL
#define	PERI_SDMMC1		42UL
#define	PERI_SDMMC2		43UL
#define	PERI_CEC1_CORE		44UL
#define	PERI_MDAI0		45UL
#define	PERI_MFLT0_DAI		46UL
#define	PERI_MSPDIF0		47UL
#define	PERI_SRCH0_CORE		48UL
#define	PERI_SRCH0_FILTER	49UL
#define	PERI_SRCH0_SPDIF	50UL
#define	PERI_PDM		51UL
#define	PERI_CEC1_SFR		52UL
#define	PERI_TSADC		53UL
#define	PERI_I2C0		54UL
#define	PERI_I2C1		55UL
#define	PERI_I2C2		56UL
#define	PERI_I2C3		57UL
#define	PERI_UART0		58UL
#define	PERI_UART1		59UL
#define	PERI_UART2		60UL
#define	PERI_UART3		61UL
#define	PERI_MDAI1		62UL
#define	PERI_MFLT1_DAI		63UL
#define	PERI_MSPDIF1		64UL
#define	PERI_MDAI2		65UL
#define	PERI_GPSB0		66UL
#define	PERI_GPSB1		67UL
#define	PERI_GPSB2		68UL
#define	PERI_GPSBMS0		69UL
#define	PERI_GPSBMS1		70UL
#define	PERI_GPSBMS2		71UL
#define	PERI_UART4		72UL
#define	PERI_AUX0_INPUT		73UL
#define	PERI_AUX1_INPUT		74UL
#define	PERI_RESERVED18		75UL
#define	PERI_MFLT2_DAI		76UL
#define	PERI_AUX0_OUTPUT	77UL
#define	PERI_AUX1_OUTPUT	78UL
#define	PERI_MSPDIF2		79UL
#define	PERI_IC_TC		80UL
#define	PERI_SRCH1_CORE		81UL
#define	PERI_SRCH1_FILTER	82UL
#define	PERI_SRCH1_SPDIF	83UL
#define	PERI_SRCH2_CORE		84UL
#define	PERI_SRCH2_FILTER	85UL
#define	PERI_SRCH2_SPDIF	86UL
#define	PERI_SRCH3_CORE		87UL
#define	PERI_SRCH3_FILTER	88UL
#define	PERI_SRCH3_SPDIF	89UL
#define	PERI_RESERVED19		90UL
#define	PERI_RESERVED20		91UL
#define	PERI_TSRX0		92UL
#define	PERI_TSRX1		93UL
#define	PERI_TSRX2		94UL
#define	PERI_TSRX3		95UL
#define	PERI_TSRX4		96UL
#define	PERI_TSRX5		97UL
#define	PERI_TSRX6		98UL
#define	PERI_TSRX7		99UL
#define	PERI_TSRX8		100UL
#define	PERI_RESERVED21		101UL
#define	PERI_RESERVED22		102UL
#define	PERI_RESERVED23		103UL
#define	PERI_CB_WDT		104UL
#define	PERI_LVDS_PHY		105UL
#define	PERI_RESERVED24		106UL
#define	PERI_RESERVED25		107UL
#define	PERI_OUT0		108UL
#define	PERI_OUT1		109UL
#define	PERI_OUT2		110UL
#define	PERI_OUT3		111UL
#define	PERI_OUT4		112UL
#define	PERI_OUT5		113UL
#define	PERI_MAX		114UL

/* I/O Bus pwdn/swreset */
#define	IOBUS_IC_TC		0UL
#define	IOBUS_CEC1		1UL
#define	IOBUS_RESERVED02	2UL
#define	IOBUS_RESERVED03	3UL
#define	IOBUS_RESERVED04	4UL
#define	IOBUS_RESERVED05	5UL
#define	IOBUS_RESERVED06	6UL
#define	IOBUS_DMA0		7UL
#define	IOBUS_DMA1		8UL
#define	IOBUS_DMA2		9UL
#define	IOBUS_DMA		10UL
#define	IOBUS_RESERVED11	11UL
#define	IOBUS_PWM		12UL
#define	IOBUS_RESERVED13	13UL
#define	IOBUS_I2C_S2		14UL
#define	IOBUS_RESERVED15	15UL
#define	IOBUS_REMOCON		16UL
#define	IOBUS_RESERVED17	17UL
#define	IOBUS_RESERVED18	18UL
#define	IOBUS_RESERVED19	19UL
#define	IOBUS_PRT		20UL
#define	IOBUS_ADMA0		21UL
#define	IOBUS_DAI0		22UL
#define	IOBUS_SPDIF0		23UL
#define	IOBUS_AUDIO0		24UL
#define	IOBUS_SR_ADMA0		25UL
#define	IOBUS_SR_DAI0		26UL
#define	IOBUS_SR_SPDIF0		27UL
#define	IOBUS_SR_AUDIO0		28UL
#define	IOBUS_I2C_M0		29UL
#define	IOBUS_I2C_M1		30UL
#define	IOBUS_I2C_M2		31UL

#define	IOBUS_I2C_M3		32UL	// 0
#define	IOBUS_I2C_S0		33UL	// 1
#define	IOBUS_I2C_S1		34UL	// 2
#define	IOBUS_I2C0		35UL	// 3
#define	IOBUS_I2C1		36UL	// 4
#define	IOBUS_RESERVED37	37UL	// 5
#define	IOBUS_RESERVED38	38UL	// 6
#define	IOBUS_RESERVED39	39UL	// 7
#define	IOBUS_RESERVED40	40UL	// 8
#define	IOBUS_RESERVED41	41UL	// 9
#define	IOBUS_RESERVED42	42UL	// 10
#define	IOBUS_RESERVED43	43UL	// 11
#define	IOBUS_RESERVED44	44UL	// 12
#define	IOBUS_RESERVED45	45UL	// 13
#define	IOBUS_RESERVED46	46UL	// 14
#define	IOBUS_RESERVED47	47UL	// 15
#define	IOBUS_RESERVED48	48UL	// 16
#define	IOBUS_GPSB_2		49UL	// 17
#define	IOBUS_RESERVED50	50UL	// 18
#define	IOBUS_GPSB0		51UL	// 19
#define	IOBUS_GPSB1		52UL	// 20
#define	IOBUS_GPSB2		53UL	// 21
#define	IOBUS_GPSB3		54UL	// 22
#define	IOBUS_GPSB4		55UL	// 23
#define	IOBUS_GPSB5		56UL	// 24
#define	IOBUS_GPSB		57UL	// 25
#define	IOBUS_RESERVED58	58UL	// 26
#define	IOBUS_I2C_S3		59UL	// 27
#define	IOBUS_I2C_M4		60UL	// 28
#define	IOBUS_I2C_M5		61UL	// 29
#define	IOBUS_I2C_M6		62UL	// 30
#define	IOBUS_I2C_M7		63UL	// 31

#define	IOBUS_UART0		64UL	// 0
#define	IOBUS_UART1		65UL	// 1
#define	IOBUS_UART2		66UL	// 2
#define	IOBUS_UART3		67UL	// 3
#define	IOBUS_UART4		68UL	// 4
#define	IOBUS_RESERVED69	69UL	// 5
#define	IOBUS_RESERVED70	70UL	// 6
#define	IOBUS_RESERVED71	71UL	// 7
#define	IOBUS_RESERVED72	72UL	// 8
#define	IOBUS_RESERVED73	73UL	// 9
#define	IOBUS_RESERVED74	74UL	// 10
#define	IOBUS_RESERVED75	75UL	// 11
#define	IOBUS_SMARTCARD4	76UL	// 12
#define	IOBUS_RESERVED77	77UL	// 13
#define	IOBUS_RESERVED78	78UL	// 14
#define	IOBUS_RESERVED79	79UL	// 15
#define	IOBUS_UDMA0		80UL	// 16
#define	IOBUS_UDMA1		81UL	// 17
#define	IOBUS_UDMA2		82UL	// 18
#define	IOBUS_UDMA3		83UL	// 19
#define	IOBUS_UART_SMARTCARD0	84UL	// 20
#define	IOBUS_UART_SMARTCARD1	85UL	// 21
#define	IOBUS_RESERVED86	86UL	// 22
#define	IOBUS_RESERVED87	87UL	// 23
#define	IOBUS_RESERVED88	88UL	// 24
#define	IOBUS_RESERVED89	89UL	// 25
#define	IOBUS_RESERVED90	90UL	// 26
#define	IOBUS_RESERVED91	91UL	// 27
#define	IOBUS_RESERVED92	92UL	// 28
#define	IOBUS_RESERVED93	93UL	// 29
#define	IOBUS_RESERVED94	94UL	// 30
#define	IOBUS_RESERVED95	95UL	// 31

#define	IOBUS_ADMA1		96UL	// 0
#define	IOBUS_DAI1		97UL	// 1
#define	IOBUS_SPDIF1		98UL	// 2
#define	IOBUS_AUDIO1		99UL	// 3
#define	IOBUS_ADMA2		100UL	// 4
#define	IOBUS_DAI2		101UL	// 5
#define	IOBUS_SPDIF2		102UL	// 6
#define	IOBUS_AUDIO2		103UL	// 7
#define	IOBUS_SR_ADMA1		104UL	// 8
#define	IOBUS_SR_DAI1		105UL	// 9
#define	IOBUS_SR_SPDIF1		106UL	// 10
#define	IOBUS_SR_AUDIO1		107UL	// 11
#define	IOBUS_SR_ADMA2		108UL	// 12
#define	IOBUS_SR_DAI2		109UL	// 13
#define	IOBUS_SR_SPDIF2		110UL	// 14
#define	IOBUS_SR_AUDIO2		111UL	// 15
#define	IOBUS_SR_ADMA3		112UL	// 16
#define	IOBUS_SR_DAI3		113UL	// 17
#define	IOBUS_SR_SPDIF3		114UL	// 18
#define	IOBUS_SR_AUDIO3		115UL	// 19

#define IOBUS_GDMA1             128UL     //  0
#define IOBUS_CIPHER            129UL     //  1
#define IOBUS_SDMMC0            130UL     //  2
#define IOBUS_SDMMC1            131UL     //  3
#define IOBUS_SDMMC2            132UL     //  4
#define IOBUS_SDMMC             133UL     //  5
#define IOBUS_SMC               134UL     //  6
#define IOBUS_NFC               135UL     //  7
#define IOBUS_EDICFG            136UL     //  8
#define IOBUS_EDI               137UL     //  9
#define IOBUS_RTC               138UL     // 10

#define	IOBUS_MAX		139UL

/* Display Bus pwdn/swreset */
#define DDIBUS_VIOC		0UL
#define DDIBUS_HDMI		2UL
#define DDIBUS_MIPI		4UL
#define DDIBUS_LVDS		5UL
#define DDIBUS_MAX		16UL

/* Video Bus pwdn/swreset */
#define VIDEOBUS_JPEG           0UL
#define VIDEOBUS_CODA_BUS       1UL
#define VIDEOBUS_CODA_CORE      2UL
#define VIDEOBUS_HEVC_BUS       3UL
#define VIDEOBUS_HEVC_CORE      4UL
#define VIDEOBUS_MAX            6UL

/* High-Speed I/O Bus pwdn/swreset */
#define HSIOBUS_RESERVED00	0UL
#define HSIOBUS_RESERVED01	1UL
#define HSIOBUS_GMAC		2UL
#define HSIOBUS_RESERVED03	3UL
#define HSIOBUS_RESERVED04	4UL
#define HSIOBUS_HSIC		5UL
#define HSIOBUS_USB20H		6UL
#define HSIOBUS_RESERVED07	7UL
#define HSIOBUS_RESERVED08	8UL
#define HSIOBUS_RESERVED09	9UL
#define HSIOBUS_RESERVED10	10UL
#define HSIOBUS_RESERVED11	11UL
#define HSIOBUS_RESERVED12	12UL
#define HSIOBUS_RESERVED13	13UL
#define HSIOBUS_RESERVED14	14UL
#define HSIOBUS_RESERVED15	15UL
#define HSIOBUS_RESERVED16	16UL
#define HSIOBUS_RESERVED17	17UL
#define HSIOBUS_CIPHER		18UL
#define HSIOBUS_USB20DH		19UL
#define HSIOBUS_RESERVED20	20UL
#define HSIOBUS_SECURE_WRAP	21UL
#define HSIOBUS_TRNG		22UL
#define HSIOBUS_RESERVED23	23UL
#define HSIOBUS_RESERVED24	24UL
#define HSIOBUS_RESERVED25	25UL
#define HSIOBUS_RESERVED26	26UL
#define HSIOBUS_RESERVED27	27UL
#define HSIOBUS_RESERVED28	28UL
#define HSIOBUS_RESERVED29	29UL
#define HSIOBUS_RESERVED30	30UL
#define HSIOBUS_RESERVED31	31UL
#define HSIOBUS_MAX		32UL

/* TOP Isolation Control */
#define ISOIP_TOP_VLD		0UL
#define ISOIP_TOP_POR		1UL
#define ISOIP_TOP_ECID		2UL
#define ISOIP_TOP_OSC		3UL
#define ISOIP_TOP_ADC		4UL
#define ISOIP_TOP_RTC		5UL
#define ISOIP_TOP_U30		6UL
#define ISOIP_TOP_U20H		7UL
#define ISOIP_TOP_U20DH		8UL
#define ISOIP_TOP_PCIE		9UL
#define ISOIP_TOP_OTP		10UL
#define ISOIP_TOP_TSEN		11UL
#define ISOIP_TOP_DPLL		12UL
#define ISOIP_TOP_NPLL		13UL
#define ISOIP_TOP_MBPLL		14UL
#define ISOIP_TOP_DMC0		16UL
#define ISOIP_TOP_MAX		17UL

/* Display Bus Isolation Control */
#define ISOIP_DDB_HDMI		0UL
#define ISOIP_DDB_LVDS		1UL
#define ISOIP_DDB_VDAC		2UL
#define ISOIP_DDB_MIPI		3UL
#define ISOIP_DDB_MAX		4UL

#endif
